﻿using System;
using System.IO;
using System.Threading;
using System.Threading.Tasks;

namespace ConsoleApplication1
{
    class Program
    {
        static void Main(string[] args)
        {
            func();

            if (false)
            {
                int workerThreads = 0;
                int cpThreads = 0;

                ThreadPool.SetMaxThreads(4, 4);

                for (int i = 0; i < 4; i++)
                {
                    ThreadPool.QueueUserWorkItem((arg) =>
                    {
                        Console.WriteLine("WorkerThread: " + arg);
                        Thread.Sleep(1000 * 5);

                    }, i);
                }

                Thread.Sleep(1000);

                ThreadPool.GetMaxThreads(out workerThreads, out cpThreads);
                Console.WriteLine(workerThreads + ", " + cpThreads);

                ReadFile();
            }

            Console.ReadLine();
        }

        static async void ReadFile()
        {
            string filePath = typeof(Program).Assembly.Location;
            FileStream fs = new FileStream(filePath, FileMode.Open, FileAccess.Read, FileShare.ReadWrite);
            byte[] buf = new byte[1024];
            await fs.ReadAsync(buf, 0, buf.Length);

            fs.Dispose();
            Console.WriteLine("Done");
        }

        static async void func2()
        {
        }

        static async void func()
        {
            //Func<int> task = new Func<int>(() =>
            //{
            //    Console.WriteLine(Thread.CurrentThread.ManagedThreadId);
            //    return 5;
            //});

            Console.WriteLine(Thread.CurrentThread.ManagedThreadId);
            int result = await Task.Run((Func<int>)userWork);
            Console.WriteLine(result);
        }

        static int userWork()
        {
            Console.WriteLine(Thread.CurrentThread.ManagedThreadId);
            return 5;
        }
    }
}
